-- 竞技场
checkRequire("Lua_FuncEntranceItem");
Lua_ArenaEntranceWindow = class("Lua_ArenaEntranceWindow", Lua_Window);
function Lua_ArenaEntranceWindow:ctor()
    self:superCall("ctor");

    self.layer = MainWinDefine.MAIN_MENU_LAYER;
    self.windowName = "Lua_ArenaEntranceWindow";
    self.isFullSizeWin = true;
    self.isFullPaving = true;
    self.showWinBg = true;
    self.winBgPath = "/images/scene/xui_yj_bg_1.jpg";
    self.showBackBtn = true;
    self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_ArenaEntranceWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.winBg.anchorValue = 4;
    self.winBg.pivotValue = 4;

    self.itemArr = Array();
    local arr = DataCenter.funcPlayUtil:getPlayArrByType(Lua_FuncPlayDefine.TYPE_ARENAE_NTRANCE);
    self.itemLen = arr:getSize();
    local vo;
    local item;
    for i = 1, self.itemLen do
        vo = arr[i];
        item = Lua_ArenaEntranceItem.new(self.content);
        item.contentName = "Lua_ArenaEntranceItem"..vo.id;
        item:setLocation(vo.showPos[1], vo.showPos[2]);
        item:setIndex(i);
        item:setData(vo);
        self.itemArr:add(item);
    end

    self:startTimer();
    self:addLuaEvent("FIGHTPLAY_ENTER", self, self.checkIsFighting);
    self:addLuaEvent("FIGHTPLAY_COMPLETE", self, self.checkIsFighting);
end

function Lua_ArenaEntranceWindow:onBackBtnClick()
    DataCenter.funcPathUtil:gotoFunction(1047, true, false);
end

function Lua_ArenaEntranceWindow:dispose()
    self:stopTimer();
    if self.itemArr then
        self.itemArr:dispose();
        self.itemArr:clear();
        self.itemArr = nil;
    end
    self:superCall("dispose");
end

function Lua_ArenaEntranceWindow:startTimer()
    if self.bTimer ~= true then
        self.bTimer = true;
        Lua_CommonUtil.addTimer("Lua_ArenaEntranceWindow", 1, self, self.onTimer);
    end
end

function Lua_ArenaEntranceWindow:stopTimer()
    if self.bTimer == true then
        self.bTimer = false;
        Lua_CommonUtil.removeTimer(self, self.onTimer);
    end
end

function Lua_ArenaEntranceWindow:onTimer()
    for i = 1, self.itemLen do
        self.itemArr[i]:onTimer();
    end
end

function Lua_ArenaEntranceWindow:checkIsFighting(templateId)
    for i = 1, self.itemLen do
        self.itemArr[i]:checkIsFighting();
    end
end










Lua_ArenaEntranceItem = class("Lua_ArenaEntranceItem", Lua_DisplayObject)
function Lua_ArenaEntranceItem:ctor(p)
    self:superCall("ctor", p, "ArenaEntranceItem_skin");
end

function Lua_ArenaEntranceItem:buildShowItem()
    self:superCall("buildShowItem");
    self.bg.clickScale = false;
    self.bg:addClickFuntion(self, self.onClick);
end

function Lua_ArenaEntranceItem:dispose()
    if self.redPoint then
        self.redPoint:dispose();
        self.redPoint = nil;
    end
    if self.fightEff then
        self.fightEff:dispose();
        self.fightEff = nil;
    end
    self.data = nil;
    self:superCall("dispose");
end

function Lua_ArenaEntranceItem:setIndex(idx)
    if idx % 2 == 1 then
        self.crossServerIcon.anchorValue = 0;
        self.crossServerIcon:setLocation(21, -37, 0);
        self.nameText.anchorValue = 6;
        self.nameText.pivotValue = 3;
        self.nameText.alignmentValue = 3;
        self.nameText:setLocation(17, 65, 0);
        self.desText.anchorValue = 6;
        self.desText.pivotValue = 3;
        self.desText.alignmentValue = 3;
        self.desText:setLocation(19, 32, 0);
    else
        self.crossServerIcon.anchorValue = 2;
        self.crossServerIcon:setLocation(-17, -37, 0);
        self.nameText.anchorValue = 8;
        self.nameText.pivotValue = 5;
        self.nameText.alignmentValue = 5;
        self.nameText:setLocation(-20, 65, 0);
        self.desText.anchorValue = 8;
        self.desText.pivotValue = 5;
        self.desText.alignmentValue = 5;
        self.desText:setLocation(-21, 32, 0);
    end
end

function Lua_ArenaEntranceItem:setData(data)
    self.data = data;
    self.bTimer = false;

    self:setRectSize(data.iconWidth, data.iconHeight);
    self.bg:setUrl(data.iconPath);
    self.bg:SetDimensions(data.iconWidth, data.iconHeight);
    self.nameText.text = data.name;

    self:updateData();
    self:checkIsFighting();
    self:setRedPoint(data.redPointId, data.redPos[1], data.redPos[2]);
end

function Lua_ArenaEntranceItem:updateData()
    local vo = DataCenter.funcOpenUtil:getFuncOpenVoById(self.data.openId);
    if self.data.id == Lua_FuncPlayDefine.FORMTEAMCOMPETITION then
        self:showFormTeamCompetitionInfo(vo.isOpen, vo.advanceMessage);
    else
        self.curTimeType = nil;
        if vo and vo.isOpen then
            self.crossServerIcon:setEnable(self.data.isOpenCrossServer);
            if self.data.id == Lua_FuncPlayDefine.ARENA then -- 斗技场
                self:showArenaInfo();
            elseif self.data.id == Lua_FuncPlayDefine.CHAMPIONSHIP then -- 精英赛
                self:showChampionshipInfo();
            elseif self.data.id == Lua_FuncPlayDefine.TIME_SPACE_RACE then -- 时空争霸
                self:showTimeSpaceRaceInfo();
            elseif self.data.id == Lua_FuncPlayDefine.PEAK_DUEL then -- 巅峰对决
                self:showPeakDuelInfo();
            elseif self.data.id == Lua_FuncPlayDefine.CHAMPION_MATH then -- 冠军赛
                self:showChampionMathInfo();
            elseif self.data.id == Lua_FuncPlayDefine.GOD_SEA_PEAK then -- 神海之巅
                self:showGodSeaPeakInfo();
            else
                self.desText:setEnable(false);
            end
        else
            self.crossServerIcon:setEnable(false);
            if vo == nil then
                self.desText:setEnable(false);
            else
                self.desText:setEnable(true);
                self.desText.text = vo.advanceMessage;
            end
        end
    end
end

function Lua_ArenaEntranceItem:setItemGray(bGray)
    if self.bg then self.bg:setGray(bGray) end;
    if self.crossServerIcon then self.crossServerIcon:setGray(bGray) end;
end

function Lua_ArenaEntranceItem:showFormTeamCompetitionInfo(bOpened, advanceMessageStr)
    self.desText:setEnable(true);
    if not bOpened then
        self.bTimer = false;
        self.crossServerIcon:setEnable(false);
        self.desText.text = advanceMessageStr;
    else
        self.crossServerIcon:setEnable(self.data.isOpenCrossServer);
        self.curTimeType, self.endTick = DataCenter.formTeamCompetitionData:checkCurTimeType(); -- 1:未开始， 2：报名期中   3：战斗期  4：休战期
        if self.endTick > 0 then
            self.bTimer = true;
            self:onTimer();
        else
            self.bTimer = false;
        end
    end
end

function Lua_ArenaEntranceItem:showArenaInfo()
    self.endTick = DataCenter.arenaData.settle_tick;
    if self.endTick > 0 then
        self.desText:setEnable(true);
        self.bTimer = true;
        self:onTimer();
    else
        self.bTimer = false;
    end
end

function Lua_ArenaEntranceItem:showChampionshipInfo()
    self.desText:setEnable(true);
    if DataCenter.championshipData.isInTime then
        self.endTick = DataCenter.championshipData.endTick;
        self.langId = 620001;
    else
        self.endTick = DataCenter.championshipData.startTick;
         self.langId = 620002;
    end
    self.bTimer = true;
    self:onTimer();
end

function Lua_ArenaEntranceItem:showTimeSpaceRaceInfo()
    self.desText:setEnable(true);
    if DataCenter.timeSpaceRaceData.isInTime then
        self.endTick = DataCenter.timeSpaceRaceData.endTick;
        self.langId = 620001;
    else
        self.endTick = DataCenter.timeSpaceRaceData.startTick;
         self.langId = 620002;
    end
    self.bTimer = true;
    self:onTimer();
end

function Lua_ArenaEntranceItem:showPeakDuelInfo()
    self.desText:setEnable(true);
    if DataCenter.peakDuelData.is_off_season == 1 then
        self.endTick = DataCenter.peakDuelData.endTick;
        self.langId = 620002;
    else
        self.endTick = DataCenter.peakDuelData.matchEndTick;
        self.langId = 620001;
    end
    self.bTimer = true;
    self:onTimer();
end

function Lua_ArenaEntranceItem:showChampionMathInfo()
    self.desText:setEnable(true);
    if DataCenter.championMatchData.isInTime then
        self.endTick = DataCenter.championMatchData.endTick;
        self.langId = 620001;
    else
        self.endTick = DataCenter.championMatchData.startTick;
         self.langId = 620002;
    end
    self.bTimer = true;
    self:onTimer();
end

function Lua_ArenaEntranceItem:showGodSeaPeakInfo()
    self.desText:setEnable(true);
    if DataCenter.godSeaPeakData.acquiredState == 1 then
        self.endTick = DataCenter.godSeaPeakData.endTick;
        self.langId = 620002;
    else
        self.endTick = DataCenter.godSeaPeakData.endTick;
        self.langId = 620001;
    end
    self.bTimer = true;
    self:onTimer();
end

function Lua_ArenaEntranceItem:onTimer()
    if not self.bTimer or self.data == nil or self.endTick == nil then
        return;
    end

    if self.data.id == Lua_FuncPlayDefine.FORMTEAMCOMPETITION then
        self.remainTime = self.endTick - DataCenter.roleData.serverTime;
       
        if self.remainTime >= 0 then
            local str;
            if self.curTimeType <= 2 then
                str = 620002;
            elseif self.curTimeType == 3 then
                str = 620001;
            else
                str = 620003;
                self.bTimer = false;
            end

            self.checkCount = 0;
            self.desText.text = LanUtil.formateStr(str, Lua_TimeTransform.transSeconds1(self.remainTime));
        else
            self.checkCount = self.checkCount or 0;
            if self.curTimeType <= 3 and self.checkCount <= 3 then
                self.checkCount = self.checkCount + 1;
                local vo = DataCenter.funcOpenUtil:getFuncOpenVoById(self.data.openId);
                self:showFormTeamCompetitionInfo(vo.isOpen, vo.advanceMessage);
            else
                self.bTimer = false;
            end
        end
    elseif self.data.id == Lua_FuncPlayDefine.ARENA then
        self.remainTime = self.endTick - DataCenter.roleData.serverTime;
        if self.remainTime > 0 then
            self.desText.text = LanUtil.formateStr(620001, Lua_TimeTransform.transSeconds1(self.remainTime));
        else
            self.bTimer = false;
            self.desText:setEnable(false);
        end
    else
        self.remainTime = self.endTick - DataCenter.roleData.serverTime;
        if self.remainTime > 0 then
            self.desText.text = LanUtil.formateStr(self.langId, Lua_TimeTransform.transSeconds1(self.remainTime));
        else
            self.bTimer = false;
            self.desText:setEnable(false);
        end
    end
end

function Lua_ArenaEntranceItem:setRedPoint(id, posX, posY)
    if strIsNullOrEmpty(id) then
        if self.redPoint then
            self.redPoint:changeRedPoint(nil);
        end
    else
        if self.redPoint == nil then
            self.redPoint = Lua_RedPointIcon.new(self.content);
        end
        self.redPoint:setLocation(posX, posY, 0);
        self.redPoint:changeRedPoint(id);
    end
end

function Lua_ArenaEntranceItem:checkIsFighting()
    self.recordId = 0;
    if self.data ~= nil and self.data.templateList ~= nil then
        local list = self.data.templateList;
        for i = 1, #list do
            self.recordId = DataCenter.fightData:getRecordIdByTemplateId(list[i]);
            if self.recordId > 0 then
                break;
            end
        end
    end
    self:showFightEff(self.recordId > 0, self.data.fightingPos[1], self.data.fightingPos[2]);
end

function Lua_ArenaEntranceItem:showFightEff(value, posX, posY)
    if value then
        if self.fightEff == nil then
            self.fightEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_ty_zdbs_0101", "ui_ty_zdbs_0101", posX, posY);
        end
        self.fightEff:setEnable(true);
    else
        if self.fightEff then
            self.fightEff:setEnable(false);
        end
    end
end

function Lua_ArenaEntranceItem:onClick(go)
    if self.data == nil then
        return;
    end

    DataCenter.funcPathUtil:gotoFunction(self.data.pathId);
end